//=============================================================================
// AugBallistic.
//=============================================================================
class AugBallistic extends Augmentation;

state Active
{
Begin:
	BulletTimeOn();
	Player.ClientFlash(0.025, vect(1000,1000,900));
}

function Deactivate()
{
	BulletTimeOff();
	Player.ClientFlash(0.025, vect(1000,1000,900));
	Super.Deactivate();
}

function BulletTimeOn()
{
	if ( Player.Level.Game != None )
		Player.Level.Game.SetGameSpeed(0.1);
}

function BulletTimeOff()
{
	if ( Player.Level.Game != None )
		Player.Level.Game.SetGameSpeed(1.0);
}

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();
}

defaultproperties
{
     EnergyRate=1500.000000
     MaxLevel=0
     Icon=Texture'DeusExUI.UserInterface.AugIconBallistic'
     smallIcon=Texture'DeusExUI.UserInterface.AugIconBallistic_Small'
     bTurnOffWhenTravel=True
     AugmentationName="Bullet Time"
     Description="Monomolecular nanoformer particles effectively allows the agent to create a slowndown effect known as 'bullet time'.|n|nNO UPGRADES"
     MPInfo="When active, you turn on the bullet time effect.  Energy Drain: Very High"
     LevelValues(0)=1.000000
     AugmentationLocation=LOC_Subdermal
     MPConflictSlot=4
}
