//=============================================================================
// Toilet.
//=============================================================================
class Toilet extends DeusExDecoration;

enum ESkinColor
{
	SC_Clean,
	SC_Filthy
};

var() ESkinColor SkinColor;
var bool bUsing;

//-----------------------------------
// Uses HDTP's models/textures if they exists ;)
function prebeginplay()
{
     local mesh HDTPmesh;
     HDTPmesh = LODMesh(dynamicloadObject("HDTPDecos.HDTPToilet",class'mesh', true));
     if(HDTPmesh != none)
     {
        mesh = HDTPmesh;
     }
 super.prebeginplay();
}
//----------------------------------------


function BeginPlay()
{
	Super.BeginPlay();

	switch (SkinColor)
	{
		case SC_Clean:	
										MultiSkins[1] = texture(dynamicloadObject("HDTPDecos.Skins.CleanHDTPToiletTex1",class'texture'));
                    MultiSkins[2] = texture(dynamicloadObject("HDTPDecos.Skins.CleanHDTPToiletTex2",class'texture'));
                    MultiSkins[3] = texture(dynamicloadObject("HDTPDecos.Skins.CleanToiletWaterTex",class'texture'));
											If ((MultiSkins[1]==none) && (MultiSkins[2]==none) && (MultiSkins[3]==none))
											{
											Skin = Texture'ToiletTex1';
											} 
										break;

		case SC_Filthy:	
										MultiSkins[1] = texture(dynamicloadObject("HDTPDecos.Skins.DirtyHDTPToiletTex1",class'texture'));
                    MultiSkins[2] = texture(dynamicloadObject("HDTPDecos.Skins.DirtyHDTPToiletTex2",class'texture'));
                    MultiSkins[3] = texture(dynamicloadObject("HDTPDecos.Skins.DirtyToiletWaterTex",class'texture'));
											If ((MultiSkins[1]==none) && (MultiSkins[2]==none) && (MultiSkins[3]==none))
											{
											Skin = Texture'ToiletTex2'; 
											} 
										break;
	}
}

function Timer()
{
	bUsing = False;
}

function Frob(actor Frobber, Inventory frobWith)
{
	Super.Frob(Frobber, frobWith);

	if (bUsing)
		return;

	SetTimer(9.0, False);
	bUsing = True;

	PlaySound(sound'FlushToilet',,,, 256);
	PlayAnim('Flush');
}

defaultproperties
{
     bInvincible=True
     ItemName="Toilet"
     bPushable=False
     Physics=PHYS_None
     Mesh=LodMesh'DeusExDeco.Toilet'
     CollisionRadius=28.000000
     CollisionHeight=28.000000
     Mass=100.000000
     Buoyancy=5.000000
}
